/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package org.dolbeau.mencgen;

import java.util.*;

import org.dolbeau.xsCOEj.*;

class lavcEncodeData implements java.io.Serializable {
    String sourceFile = "test.avi";
    String extraOpts = "";
    int aid = 1;
    String videoFilter = "";
    String audioCodec = "copy"; // "mp3lame";
    String audioOptions = "" ;  // "-lameopts preset=medium";
    String output = "/dev/null";
    OptionInstanceList lavcOpts = null;
    String workdir = lavcGeneticMain.kDefaultWorkdir;
    lavcCodecData codecData = null;
    int bitrate = 0;
    
    String getLacvOptsString() {
        return lavcOpts.toPrettyString(":");
    }

    lavcEncodeData(OptionInstanceList lo, lavcCodecData cd) {
        lavcOpts = new OptionInstanceList(lo);
        codecData = cd;
    }

    public String toString() {
        return
            "\tSource File: " + sourceFile + "\n" +
            "\tExtra Opts: " + extraOpts + "\n" +
            "\tAudio Id: " + aid + "\n" +
            "\tVideo Filter: " + videoFilter + "\n" +
            "\tAudio Codec: " + audioCodec + "\n" +
            "\tAudio Options: " + audioOptions + "\n" +
            "\tOutput File: " + output + "\n" +
            "\tCodec Options: " + getLacvOptsString() + "\n" +
            "\tBitrate: " + bitrate + "\n" +
            "\tWorkdir: " + workdir + "\n" +
            codecData;
    }
}
