/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package org.dolbeau.xsCOEj;

import java.util.*;

/**
 * The Class to handle the locked, threaded distribution of the String of a Set.
 * Used for the distribution of host names.
 * @author Romain Dolbeau <romain@dolbeau.org>
 * @version  $Id: JobDist.java,v 1.1.1.1 2004/12/06 13:52:41 dolbeau Exp $
 */
public class JobDist {
    private List allMachines;
    
    public JobDist(List am) {
        allMachines = Collections.synchronizedList(new ArrayList(am));
    }

    public String getMachine() {
        String temp = null;

        while (temp == null) {
            synchronized(allMachines) {
                if (allMachines.size() > 0) {
                    temp = (String)allMachines.get(0);
                    allMachines.remove(temp);
                }                
            }
            if (temp == null) {
                try {
                    synchronized (this) {
                        this.wait(60);
                    }
                } catch (Exception e) { }
            }
        }
        
        return temp;
    }

    public void returnMachine(String m) {
        synchronized(allMachines) {
            allMachines.add(m);
        }
    }
}
