/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

package org.dolbeau.xsCOEj;

import java.util.*;
import javax.swing.*;
import java.awt.event.*;

public class OptionDisplayersPanel extends JPanel {
    private Set allPanels = new HashSet();
    
    public OptionDisplayersPanel(Set allOptions) {
        setLayout(new java.awt.GridLayout(0, 2));
        Iterator it = allOptions.iterator();
        while(it.hasNext()) {
            Option opt = (Option)it.next();
            if (opt.getAllInstances().size() > 1) {
                OptionDisplayer lod = new OptionDisplayer(opt);
                add(lod);
                allPanels.add(lod);
            }
        }
    }

    public void updateAllDisplayers(ResultsPool lrp, int step) {
        Map statMap = lrp.getStatisticsMap();
        int nst = lrp.numberOfResults();
        Iterator it = allPanels.iterator();
        while(it.hasNext()) {
            OptionDisplayer lod = (OptionDisplayer)it.next();
            lod.buildCharts(statMap, step, nst);
        }
    }
}
