/* 
 * Copyright (C) 2004 Romain Dolbeau <romain@dolbeau.org>
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */

/* bad class name, it's not a List it's a Set */

package org.dolbeau.xsCOEj;

import java.util.*;

public abstract class OptionInstanceIncompatibleList extends OptionInstance {
    private Set incompatibles = new HashSet();

    public OptionInstanceIncompatibleList(Option p) {
        super(p);
    }

    public Set getIncompatibles() {
        return Collections.unmodifiableSet(incompatibles);
    }

    public void addIncompatible(OptionInstance oi) {
        incompatibles.add(oi);
    }

    public void addIncompatible(Collection c) {
        incompatibles.addAll(c);
    }

    public boolean isCompatible(OptionInstance oi) {
        return !incompatibles.contains(oi);
    }
}
